//////////////////////////////////////////
// app_init
// library for applications
//////////////////////////////////////////

var params = {};																								// public params
var retina = false;																								// wel of niet hoge resolutie toevoeging img bij hoge resolution = '@2x',
var retina_ext = '@2x';																							// retine extensie voor images
var version = '1.1';																							// api version
var app_version = '1.2.1'; 																						// app version
var proxy = is_cordova() ? '' : 'maris_proxy.php?url=';															// querystring parameters
!function (app) {

	if(!app.content) app.content = {};

	app.cordovaReady = $.Deferred();
	app.jqmReady = $.Deferred();
	app.appLoading = $.Deferred();



	$(document).one('deviceready', function (e){
		app.cordovaReady.resolve();
	});

	$(document).one('mobileinit', function (e){
		app.jqmReady.resolve();

		//If not Phonegap
		if (location.protocol.indexOf('http') > -1) {
			params['is_cordova'] = false;
			app.cordovaReady.resolve();
		}
	});

	$.when(app.cordovaReady, app.jqmReady, app.appLoading).then(function () {
		retina = app.is_retina();
		app.init();

		if (device.platform.match(/Android/) && parseFloat(device.version) < 4.4) {
			$.mobile.defaultPageTransition   = 'none';
			$.mobile.defaultDialogTransition = 'none';
		}



			$(document).on('vmousedown', 'a[href^=http], a[href^=https]', function(e){
				e.preventDefault();
				var $this = $(this);
				var target = '_system';
				window.open($this.attr('href'), target, 'location=yes');
		});
	});

}(m_application);

// Router

m_application.init = function () {
	var last = '';
	$.mobile.document
		.on("pagecontainerbeforetransition", function (event, data) {
			$('html').addClass('no_scroll');
		})
		.on('pagecontainertransition', function (event, data) {
			$('html').removeClass('no_scroll');
		});

	$.mobile.document.on("pagecontainerbeforetransition", function (event, data) {
			//data.absUrl = event.currentTarget.baseURI;
			if (last == data.absUrl) {
				return;
			} else {
				last = data.absUrl;
			}

			process_hash(data.absUrl);

			if (data.toPage) {
				$(data.toPage).empty();
				$(data.toPage).html(m_application.ShadowDOM[0].querySelector(params.hash).innerHTML);//.enhanceWithin(); // performance
			}

			m_application.route();
			$(data.toPage).jqmData("url", params.hash);
	});




	$(document).on('click touchend','.pre_dev', function (e) {e.preventDefault();e.stopPropagation();});

	//location.hash = "splash";
	go('splash');
	//$.mobile.navigate("#splash");
	//$('body').fadeIn();
	if (is_cordova()) {
		navigator.splashscreen.hide();
		setTimeout(navigator.splashscreen.hide, 3000); // Just in case!
	}

};

// go('home', {id: 432})
function go(page, query) {
	var hash = page;
	if (query && (query instanceof Object)) {
		var temp_query = [];
		$.each(query, function (key, value) {
			temp_query.push([key, '=', value].join(''));
		});
		if (temp_query.length) {
			hash += '?' + temp_query.join('&');

		}
	}
	//location.hash = hash;
	$.mobile.navigate( "#" + hash );
}


// querystring

function process_hash(url) {
	params['parsed'] = $.mobile.path.parseUrl(url);


	var hash_query = params.parsed.hash.split("?");										// Create name: value pairs from the query parameters


	$.each((hash_query.length > 1 ? hash_query[1] : "").split("&"), function () {
		var pair = this.split("=");
		if (pair.length > 0 && pair[0]) {
			params[pair[0]] = (pair.length > 1 ? pair[1] : true);					// paramters los
		}
	});

	params['hash']	= (hash_query.length > 0 ? hash_query[0] : "");		// #home etc
}

// sort array/object

//function sort_by (prop, modifier) {
//	return function (a, b) {
//				mod = modifier || function (i) {return i};
//				if (mod(a[prop]) < mod(b[prop])) return -1;
//				if (mod(a[prop]) > mod(b[prop])) return 1;
//				return 0;
//			};
//}
	function sortBy (prop, dir, modifier) {
		var x = (dir ? 1: -1);
		return function (a, b) {
			mod = modifier || function (i) {return i};
			if (mod(a[prop]) < mod(b[prop])) return -x;
			if (mod(a[prop]) > mod(b[prop])) return x;
			return 0;
		};
	}

	function mobile_alert(_obj) {																				// html alert, app = phonecap nice alert
		var obj = $.extend({button: 'ok'}, _obj);
		if (is_cordova()) {
			return navigator.notification.alert(
				obj.message,
				obj.cb,
				obj.title,
				obj.button
			);

		} else {
			return alert(JSON.stringify(obj));
		}
	}

	function mobile_confirm(_obj) {																				// html alert, app = phonecap nice alert (return 1 false en 2 ok)
		var obj = $.extend({button: ['cancel','ok']}, _obj);
		if (is_cordova()) {
			navigator.notification.confirm(
			    obj.message,
				obj.cb,
				obj.title,
				obj.button
			);

		} else {
			var resp = confirm(JSON.stringify(obj));
			var result = (resp ? 2 : 1);
			if (obj.cb) {
				call(obj.cb, result);
			} else {
				return result;
			}
		}
	}


	function call(cb, args) {																					// Calls callback if available and a function.
		if(cb && typeof cb === 'function') cb.call(this, args);

	}

	function fill_select(options, null_value) {
		var option_list = [];
		[].forEach.call(options, function (item) {
			option_list.push($("<option>").val(item.value).html(item.title));
		});
		if (null_value) {
			option_list.unshift($("<option>").val("").html(null_value));
		}
		return option_list;
	}


	$.orientation  = function () {
			return ($(window).width() > $(window).height()) ? 90 : 0;
	};

	$.is_landscape  = function () {
			return 	!!$.orientation();
	};


	$.fn.img_load = function (callback) {
			if (!callback) return;
			return this.each(function () {
				if ( this.complete ) {
					callback.apply(this);
				} else {
					$(this).on('load', function () {
						callback.apply(this);
					});
					}
				});
	};

	$.rnd = function () {
		var dd=new Date();
		return((Math.round(Math.abs(Math.sin(dd.getTime()))*1000000000)));
	};

	$.debounce =  function (func, wait, throttle) {
		var timeout = false;
		var max_wait = +(new Date()) + wait;

		return function () {
			var context = this;
			var args = arguments;

			if (timeout) {
				clearTimeout(timeout);
			}

            if (throttle && max_wait < +(new Date())) {
				func.apply(context, args);
                max_wait = +(new Date()) + wait;
            }

			var debounced = function () {
				timeout = null;
				func.apply(context, args);
			};

			timeout = setTimeout(debounced, wait);

		};

	};
	$.throttle = function (fun, delay) {
		return $.debounce(fun, delay, true);
	};
// search in object

if (!Array.prototype.find) {
  Array.prototype.find = function(predicate) {
    if (this == null) {
      throw new TypeError('Array.prototype.find called on null or undefined');
    }
    if (typeof predicate !== 'function') {
      throw new TypeError('predicate must be a function');
    }
    var list = Object(this);
    var length = list.length >>> 0;
    var thisArg = arguments[1];
    var value;

    for (var i = 0; i < length; i++) {
      value = list[i];
      if (predicate.call(thisArg, value, i, list)) {
        return value;
      }
    }
    return undefined;
  };
}

!function(app){
	//VERSIE 0.1
	function Gallery (options) {
		if (!(this instanceof Gallery)) return new Gallery(options);
		var _this = this;
		var selector = options.selector;
		_this.id = (new Date()).getTime();

		var slider = null;
		var viewport_ul = null;
		var slide_width = null;
		var slider_viewport = null;
		var slider_left = null;
		var single_slide = false;
		var slide_count = 0;
		var current_index = 0;

		var find_all = function (current_gallery) {
			return $('[data-gallery="'+current_gallery+'"]');
		};

		function start_slider () {
			var current_slide = $(this);
			var current_gallery = current_slide.data('gallery');
			if (!current_gallery) {
				single_slide = true;
			}

			var gallery_images = find_all(current_gallery);
			current_index = gallery_images.index( current_slide );
			gallery_images = gallery_images.clone();

			gallery_images.each(function (i, el) {
				$(el).attr('data-index', i);
			});

			slider = $('<div>', {class:'mobile_gallery_slider'});


			var gallery = app.Overlay({content: slider});
			var slider_offset = slider.offset();

			slider.height($(window).innerHeight() - slider_offset.top - 20);

			history.pushState({}, null, '');						//Dummy state to cancel back button once

			var rebuild = function () {
				var current = slider.find('li').eq(1);
				current_index = current.data('index');
				slider.empty().off();
				slider.height($(window).innerHeight() - slider_offset.top - 20);
				build_slider(gallery_images, current_index);
			};

			var cleanup = function () {
				history.back();

			};



			$(window).on('resize', rebuild);

			$(window).one('navigate', function () {
				gallery.close(true);
			});

			gallery.done(cleanup);
			gallery.done(function () {
				$(window).off('resize', rebuild);
			});

			var content = build_slider(gallery_images, current_index);
		}

		function build_slider (_images, start_index) {
			var ul  = $('<ul>');
			viewport_ul = ul;
			var slides = $();
			var images = _images.clone();
			slide_count = _images.length;
			if (_images.length === 1) {
				single_slide = true;
			}

			if (start_index > 0) {
				var new_list = images.slice(start_index).add(images.slice(0, start_index));
				images = new_list;
			}
			// Create image conainer: LI > DIV > IMG + DIV

			$.map(images, function (el, i) {
				var slide = $(el);
				var image = $('<img>',{src: slide.data('href'), on: {load: function () {
					$(this).parent().width(this.width);
				}}});
				var description = $('<div>', {class:'photo-box-description', text: slide.data('description')});
				slides = slides.add($('<li>', {data: {index: slide.data('index')}}).append($('<div>').append(image).append(description)));
			});

			slider.append(ul.append(slides));

			slide_width = viewport_ul.find('li').outerWidth();
			slide_width = slider.innerWidth();
			var viewport_li = viewport_ul.find('li');
			viewport_li
				.width(slide_width)
				.find('img')
					.css('max-width', slide_width)
					.css('max-height','100%');

			viewport_li.children('div').height(slider.height());

		 	slider_viewport = slide_width * slides.length;
			slider_left = slide_width * -1;

			if (single_slide) {
				ul.css({
					width: slider_viewport
				});

			} else {
				ul.css({
					width: slider_viewport,
					'left': slider_left
				});
				ul.find('li').first().before(ul.find('li').last());

				slider.on('swipeleft', _this.move_right);
				slider.on('swiperight',_this.move_left);
			}
			return slider;
		}

		_this.move_left = function() {
			var left = parseInt(viewport_ul.css('left')) + slide_width;
			viewport_ul.animate({
				'left': left
			},200, function () {
				viewport_ul.find('li').first().before(viewport_ul.find('li').last());
				viewport_ul.css({'left' : slider_left});
			});

		};

		_this.move_right = function() {
			var left = parseInt(viewport_ul.css('left')) - slide_width;
			viewport_ul.animate({
				'left': left
			},200, function () {
				viewport_ul.find('li').last().after(viewport_ul.find('li').first());
				viewport_ul.css({'left' : slider_left});
			});

		};

		$(selector).on('vclick', start_slider);
	}

	app.Gallery = Gallery;

}(m_application);
// overlay
!function(app){
	//namespace
	function Overlay (options) {
		if (!(this instanceof Overlay)) return new Overlay(options);
		var _this = this;
		_this.container = null;
		_this.id = (new Date()).getTime();
		options = options || {};
		options.content = options.content || '';
		options.class 	= options.class || [];

		_this.doneEvents = options.done ? [options.done] : [];

		var content = $("<div>",{class: ' mobile_expand_content ' + options.class.join(' ')}).append(options.content);
		var parent = $('<div>',{class: ' mobile_expand_scroller '}).append(content);

		_this.container = $('<div>', {class: 'mobile-expand'})
			.append(parent);

		parent.prepend("<img class='mobile-expand-close' src='grfx/close_overlay.png'  alt='menu nav close' />");

		_this.container.find('.mobile-expand-close').one('click', function (e){
			e.stopPropagation();
			_this.close();
		});

		_this.container.show().appendTo($('body'));

		$('body, html').addClass('no_scroll');

		$( _this.container ).one('Overlay:done', function (e) {
				_this.onDone();
		});
	}

	Overlay.prototype.close = function (silent) {
		if (!silent) {
			$( this.container ).trigger(jQuery.Event( "Overlay:done", {overlay_id: this.id} ) );
		}
		$('body, html').removeClass('no_scroll');
		this.container.remove();
	};

	Overlay.prototype.onDone = function () {
		this.doneEvents.forEach(function(cb){
			setTimeout(cb , 0);
		});
	};
	Overlay.prototype.done = function (cb) {
		this.doneEvents.push(cb);
		return this;
	};


	app.Overlay = Overlay;
}(m_application);


// database
!function(app){

	function init (options) {
	}

	function clear () {
		localStorage.clear();								// pas op clear=delete de hele database
	}

	function find (key, cb) {
		var result = JSON.parse(localStorage.getItem(key));
		cb(result);
	}

	function save (key, item, cb) {
		localStorage.setItem(key, JSON.stringify(item));
		(cb && cb(item))
	}

	function remove (key, cb) {
		localStorage.removeItem(key);
		(cb && cb());
	}

	function is_empty () {
		return !Object.keys(localStorage).length;
	}

	app.database = {
		init 		: init,
		find 		: find,
		delete		: remove,
		save 		: save,
		clear		: clear,
		is_empty 	: is_empty
	};
}(m_application);

!function(app){
	app.is_retina = function(){
		var mediaQuery = '(-webkit-min-device-pixel-ratio: 1.5), (min--moz-device-pixel-ratio: 1.5), (-o-min-device-pixel-ratio: 3/2), (min-resolution: 1.5dppx)';

		if (window.devicePixelRatio > 1) {
			return true;
		}

		if (window.matchMedia && window.matchMedia(mediaQuery).matches) {
			return true;
		}

		return false;
	};
}(m_application);
