!(function (app) {


	app.content.beach = function () {
//		app.database.clear();
//		save_beach_to_favorites()

		build_beach_list();
		app.content_header({header:beach_title(),
			sidebar: false
			// sidebar_items: [
			// 	{target:'', 		label:'Add to Favorites', class:'add_to_favorites'}
			// ]
		});
		app.content_footer();

		$('#beach [data-role="header"]').append('<a href="#"  role="button" class="ui-nodisc-icon ui-btn-icon-notext ui-nodisc-icon ui-icon-heart ui-btn-right add_to_favorites">&nbsp;</a>').enhanceWithin();


// check favorites
		function check_favorites () {

			app.database.find('favorites', function (result) {
				result = result || {};
				if (!result[params.beach]) {
					$('.add_to_favorites').removeClass('ui-icon-heart-fill').addClass('ui-icon-heart');
				} else {
					$('.add_to_favorites').removeClass('ui-icon-heart').addClass('ui-icon-heart-fill');
				}

			});
		}

		check_favorites();
		$(".add_to_favorites").on('click', function () {																	// add to favorites
				add_or_remove(check_favorites);
		});

	};

	function add_or_remove(cb) {
		app.database.find('favorites', function (result) {
			result = result || {};

			if (!result[params.beach]) {
				result[params.beach] = {beach:params.beach, region:params.region};
				app.database.save('favorites',result, cb);
			} else {
				delete result[params.beach];
				app.database.save('favorites',result, cb);
			}

		});

	}

	function build_beach_list() {

		var a_beach_list = [
			{target:'#beach_detail', 		special:false, 	label:'Beach Information',		params:'?region='+params.region+'&beach='+params.beach},
			{target:'#beach_weather',		special:false, 	label:'Weather Forecast',		params:''},
			{target:'#', 					special:true, 	label:'Marine Forecast',		params:'?region='+params.region+'&beach='+params.beach},
			{target:'#', 					special:false, 	label:'Photos',					params:'?region='+params.region+'&beach='+params.beach},
			{target:'#beach_map', 			special:false, 	label:'Local Map',				params:'?region='+params.region+'&beach='+params.beach}
		];

	    a_beach_list = [
			{target:'#beach_detail'		, label:'Beach Information', params:'?region='+params.region+'&beach='+params.beach},
			{target:'#beach_weather'	, label:'Weather Forecast',  params:'?region='+params.region+'&beach='+params.beach},
			{target:'#'					, label:'Marine Forecast', 	 params:'?region='+params.region+'&beach='+params.beach,
				children: [
					{target:'#marine_map'	, label:'Map', 	 	 		params:'?region='+params.region+'&beach='+params.beach},
					{target:'#marine_table'	, label:'Table', 	 		params:'?region='+params.region+'&beach='+params.beach}
				]},
			{target:'#'					, label:'Photos',			 params:'?region='+params.region+'&beach='+params.beach,
				children: [
					{target:'#photos'	, label:'Photo Gallery', 	 	params:'?region='+params.region+'&beach='+params.beach},
					{target:'#photo'	, label:'Upload Photo', 	 	params:'?region='+params.region+'&beach='+params.beach}

				]},
			{target:'#beach_map'		, label:'Local Map',  		 params:'?region='+params.region+'&beach='+params.beach}

		];


		var beaches_ui = jQuery("#beach_info").empty();

		///*
		var add_item = function (parent, item) {
			var li = $('<li>', {
				class: 'ui-nodisc-icon no-sub',
			});
			var a =  $('<a>', {
				text: item.label,
				href: item.target+item.params
			});

			li.append(a);
			parent.append(li);
			return li;
		};

		$.each(a_beach_list, function (_, item) {
			if (item.children && item.children.length) {

				var sub = add_item(beaches_ui, item)
					.text('')
					.removeClass('no-sub')
					.addClass('ui-nodisc-icon')
					.attr({
						'data-role':'collapsible',
						'data-expanded-icon': 'carat-u',
						'data-iconpos':'right',
						'data-inset':'false',
						'data-collapsed-icon':'carat-d'
					});

				var h2 = $('<h2>', {
					text: item.label,
				}).appendTo(sub);

				var ul = $('<ul>', {
					'data-role': 'listview',
					'data-filter':'false',
				}).appendTo(sub);

				$.map(item.children, $.proxy(add_item, null, ul));
				ul.find('a').css('margin-left', 20);

			} else {
				add_item(beaches_ui, item);
			}
		});

		//*/

		/*
		jQuery.each(a_beach_list, function(index, value) {

			if (value.special) {
				jQuery(beaches_ui).append('<li data-region="'+ value.label +'" data-role="collapsible" data-iconpos="right" data-inset="false" data-collapsed-icon="carat-d" data-expanded-icon="carat-u" class="ui-nodisc-icon"><h2>'+value.label+'</h2></li>');
				jQuery("#beach_info li:last-child").append('<ul data-role="listview" data-theme="a" data-filter="false"></ul>');

				jQuery(beaches_ui).collapsible().trigger("create");

				jQuery("#beach_info li:last-child").trigger('create');

				var sub_beaches_ui = jQuery('*[data-region="'+ value.label +'"] ul');
					jQuery(sub_beaches_ui).append('<li><a href="#marine_map'+value.params+'">Map</a></li>');
					jQuery(sub_beaches_ui).append('<li><a href="#marine_table'+value.params+'">Table</a></li>');
				jQuery(sub_beaches_ui).listview("refresh");

			} else {
				jQuery(beaches_ui).append('<li class="no-sub ui-nodisc-icon"><a href="'+value.target+value.params+'">'+value.label +'</a></li>');
			}
		});
		*/
	}

})(m_application);
