!(function (app) {

	var wifi = false;

	app.content.home = function () {
		get_regions();
		app.content_header({back:false, sidebar: false});
		app.content_footer();
	};



///////////////////////////////////////////
// read the regiosd from
// wifi / database/ maris sever or seamobile server
///////////////////////////////////////////

	function read_regions(cb) {

		get_json('list_regions', function (result) {
			cb(result.regions);
		});
	};

///////////////////////////////////////////
// get all regions
///////////////////////////////////////////

	function get_regions(cb) {

		var regions =[];

		read_regions(function (result) {
			display_regions(result);
		});

///////////////////////////////////////////
// display the regions and beaches
///////////////////////////////////////////

		function display_regions (regions) {

			var regions_ui = jQuery("#regions").empty();
			regions.sort();
			jQuery.each(regions, function(index, region) {

				jQuery(regions_ui).append('<li data-region="'+ region +'" data-role="collapsible" data-iconpos="right" data-inset="false" data-collapsed-icon="carat-d" data-expanded-icon="carat-u" class="ui-nodisc-icon"><h2>'+ region.humanise() +'</h2></li>');

				jQuery("#regions li:last-child").append('<ul data-role="listview" data-theme="a" data-filter="false"></ul>');
				jQuery(regions_ui).collapsible().trigger("create");

				jQuery("#regions li:last-child").trigger('create');

				get_beaches(region);
			});

			jQuery("#regions ul").listview("refresh");
			jQuery("#regions").listview("refresh");
		}


	};

	function get_beaches(region) {

		var beaches = [];

		read_beaches(region, function (result) {
			display_beaches(result);
		});



		function display_beaches(beaches) {

			var beaches_ui = jQuery('*[data-region="'+ region +'"] ul');
			beaches.sort();
			jQuery.each(beaches, function(index, beach) {
				jQuery(beaches_ui).append('<li><a href="#beach?region='+ region +'&beach='+ beach +'">'+ beach.humanise() +'</a></li>');
			})
			jQuery(beaches_ui).listview("refresh");
			jQuery("#regions").listview("refresh");
		}


	};

	function read_beaches(region, cb) {
		database_region = false;

		if (wifi || !database_region) {																			// always read from internet

			get_json('list_beaches/'+region, function (result) {
			cb(result.beaches);
			});

		}

	};


})(m_application);
