!function (app) {
	app.content.map = function () {
		app.content_header({
			sidebar: false,
			 sidebar_items: [
			 	{target:'', 	label:'OpenStreetMap',  	class:'activate_base', data: {m_key: 'osm'}},
				{target:'', 	label:'EMODnet Bathymetry',  class:'activate_base', data: {m_key: 'emodnet_mean_land'}}
			//	{target:'',		label:'Bing', 				class:'activate_base', data: {m_key: 'bing'}},
			//	{target:'',		label:'Bing satellite', 	class:'activate_base', data: {m_key: 'bing_sat'}},
			//	{target:'', 	label:'Bing with Labels', 	class:'activate_base', data: {m_key: 'bing_labels'}}
			 ]
		});
		app.content_footer();
		$(document).one('pagecontainertransition', function () {

			window.load_layers_applic = function () {
				/*
				var beaches_geojson = new ol.source.GeoJSON({
					'projection': 'EPSG:3857',
					'url': 'http://apk.seamobile/www/get_data3.php?version=1.0&url=geo_json_beach'
				});

				var beaches_layer = new ol.layer.Vector({
					source: beaches_geojson,
					style: new ol.style.Style({
					    image: new ol.style.Icon(({
					        anchor: [13, 37],
					        anchorXUnits: 'pixels',
					        anchorYUnits: 'pixels',
					        src: 'grfx/map_icon.png'
					    }))
					})
				});

				layers.l [layers.l.length] = beaches_layer;
				var beaches_layer = new ol.layer.Vector({
					source: beaches_geojson,

				});

				layers.l [layers.l.length] = beaches_layer;

				*/

				var regions_geojson = new ol.source.GeoJSON({
					'projection': 'EPSG:3857',
					'url': proxy + 'http://apkseamobile.maris2.nl/get_data.php?version='+version+'&url=geo_json_regions'
				});

				var regions_layer = new ol.layer.Vector({
					source: regions_geojson,
					style: function (feature) {
					 return [new ol.style.Style({
							text: new ol.style.Text({
						        font: 'bolder 16px helvetica,sans-serif',
						        text: feature.get('name').humanise(),
						        fill: new ol.style.Fill({color: 'white'}),
						        stroke: new ol.style.Stroke({color: 'black', width: 1}),
						      })
	  					})];
				    }
				});

				layers.l [layers.l.length] = regions_layer;
				layers.l [layers.l.length] = new ol.layer.Image({title: "Regions", visible: true, m_key: 'regions', info_format_type:'text/html', is_query_layer: true, opacity: 0.5, source: new ol.source.ImageWMS({projection: 'EPSG:900913',ratio:1,url: proxy + 'http://geoservice.maris2.nl/wms/seamobile/?',params: {'VERSION': "1.1.1",'LAYERS': 'regions'}})});
			};

			map_init('map_div_map');


			window.osm_extra_layers('regions');


			identify = true;																					// set identify on getfeature_layer = auto on last loaded layer


			var current_base = layers.l.filter(function (l) { return l.get('is_base') && l.get('visible');})[0];
			$('#side-menu .close').on('vmousedown', function () {
				$('#side-menu').panel('close');
			});
			$('.activate_base').each(function () {
				var l = $(this);
				if (l.data('m_key') == current_base.get('m_key')) {
					l.addClass('active-base');
				}
			});

			$('.activate_base').on('tap', function () {
				var item = $(this);
				var m_key = item.data('m_key');
				var base_layers = layers.l.filter(function (l) { return l.get('is_base');});
				$('.activate_base').removeClass('active-base');
				item.addClass('active-base');

				$.each(base_layers, function (_, layer) {
					if (layer.get('m_key') == m_key) {
						layer.setVisible(true);
					} else {
						layer.setVisible(false);
					}
				});
			});



		});

		 show_identify_box = function(event)  {
			if (event) {
				if (getfeature_layer != 'undefined' ) {
					var layer_to_query = layers.l[getfeature_layer];
					if (layer_to_query.getVisible()) {

						var url = show_identify_box_url(event, layer_to_query, {projection: 'EPSG:900913'});											// create idenitfy url for this layer

						if (url) {																						// test url
							$.get(url, function (data) {																// get the url
								if (data !== '') {
									go('map_region', {region: data});
								}
							});
						}
					}
				}

			}

		}


	};


}(m_application);
