!function (app) {
	app.content.map_region = function () {
		app.content_header({header: params.region});
		app.content_footer();
		var beaches_layer;
		var beaches_geojson;

		$(document).one('pagecontainertransition', function () {

			window.load_layers_applic = function () {


				var regions_geojson = new ol.source.GeoJSON({
					'projection': 'EPSG:3857',
					'url': proxy + 'http://apkseamobile.maris2.nl/get_data.php?version='+version+'&url=geo_json_regions'
				});

				var regions_layer = new ol.layer.Vector({
					source: regions_geojson,
					m_key: 'regions',
					style: function (feature) {
					 return [new ol.style.Style({
							text: new ol.style.Text({
						        font: 'bolder 16px helvetica,sans-serif',
						        text: feature.get('name').humanise(),
						        fill: new ol.style.Fill({color: 'black'}),
						        stroke: new ol.style.Stroke({color: 'black', width: 1}),
						      })
	  					})];
				    }
				});




				 beaches_geojson = new ol.source.GeoJSON({
					'projection': 'EPSG:3857',
					'url': proxy + 'http://apkseamobile.maris2.nl/get_data.php?version='+version+'&url=geo_json_beach&region='+params.region
				});

				beaches_layer = new ol.layer.Vector({
					source: beaches_geojson,
					style: new ol.style.Style({
					    image: new ol.style.Icon(({
					        anchor: [13, 37],
					        anchorXUnits: 'pixels',
					        anchorYUnits: 'pixels',
					        src: 'grfx/map_icon.png'
					    }))
					})
				});

				layers.l [layers.l.length] = beaches_layer;

				layers.l [layers.l.length] = regions_layer;

			};

			map_init('map_div_map_region');
			identify = false;																					// set identify on getfeature_layer = auto on last loaded layer
			window.osm_extra_layers('regions');

			zoom_in_on_ready();

			map.on('singleclick', function (evt) {

				var feature = map.forEachFeatureAtPixel(evt.pixel, function (f) {
					return f;
				});

				if (feature) {

					params.beach = feature.get('beach');
					go('beach');
				}
			});

			function zoom_in_on_ready() {
				var vector_event = null;
				vector_event = beaches_geojson.on('change', function(e){
					if (this.getState() == 'ready') {
						var feature_layer = this;
						feature_layer.unByKey(vector_event);
						map.getView().fitExtent(feature_layer.getExtent(), map.getSize());
						if (map.getView().getResolution() < 9.547) {
							map.getView().setResolution(9.547);

						}

					}
				});
			}


		});
	};



}(m_application);
