//Setup namespace for app
window.seamobile = m_application = {};

function is_cordova () {
		return false || !document.URL.match(/^https?/);
}

function load_css (url) {
	$('<link>',{rel:'stylesheet',type:'text/css','href': url}).appendTo('head');
}

function load_styles (urls) {
	$.each(urls, function (_, url) {
		load_css(url);
	});
}

function load_script2(url, env) {
	var def = $.Deferred();
	/*
	var data_type = 'script';

	if (env === 'web') {
		//if (url.match(/^https?/)) {
			url = base_url() + url;

		//}

		//data_type = 'text';
	}
	function base_url () {
		var path = location.pathname.split('.')[0].split('/').slice(0,-1);
		return location.protocol +'//'+ location.host + path.join('/')+'/';
	}
	function step (data) {

		if (data_type !== 'script') { // Van jQuery src
			if ( data && jQuery.trim( data ) ) {
				data = '//@ sourceURL=' + base_url() + url +' \n' + data;
			// We use execScript on Internet Explorer
			// We use an anonymous function so that context is window
			// rather than jQuery in Firefox
			( window.execScript || function( data ) {
				window[ "eval" ].call( window, data );
			} )( data );
			}
		}
	}
	/*
	jQuery.ajax({
		async: false,
		url: url,
		dataType:data_type,
		contentType: 'application/javascript',
		cache:false
	}).then(step).always(def.resolve);
	*/

	$('html').append($("<script>", {type: 'text/javascript', src: url}));
	return def.promise();
}

function load_scripts (_urls, env) {
	var urls = _urls.slice();

	var process = function () {
		if (!urls.length) return;
		var url = urls.shift();
		$.when(load_script(url, env)).then(process);
	}
	process();
}


!function(phone){
	var env = phone ? 'cordova' : 'web';
	var styles = {
		cordova : [
			'vendor/jquery.mobile-1.4.5/jquery.mobile.structure-1.4.5.min.css',
			'vendor/jquery.mobile-1.4.5/jquery.mobile.theme-1.4.5.min.css',
			'vendor/jquery.mobile-1.4.5/jquery.mobile.icons-1.4.5.min.css',
			'vendor/jquery.mobile-1.4.5/jquery.mobile.inline-svg-1.4.5.min.css',
			'vendor/ol3/ol_3.4.css',
			'css/style.css'
		],
		web: [
			'vendor/jquery.mobile-1.4.5/jquery.mobile.structure-1.4.5.min.css',
			'vendor/jquery.mobile-1.4.5/jquery.mobile.theme-1.4.5.min.css',
			'vendor/jquery.mobile-1.4.5/jquery.mobile.icons-1.4.5.min.css',
			'vendor/jquery.mobile-1.4.5/jquery.mobile.inline-svg-1.4.5.min.css',
			'vendor/ol3/ol_3.4.css',
			'css/style.css'
		]
	};

	var scripts = {
		cordova: [
			'cordova.js',
			'js/apk_library.js',
			'vendor/jquery.mobile-1.4.5/jquery.mobile-1.4.5.min.js',
			'vendor/ftlabs/fastclick.js',
			'vendor/ol3/ol_3.4.js',
			'js/map_functions.js',
			'js/map_functions_mobile.js',
			'js/content/startup.js',
			'js/content/home.js',
			'js/content/favorites.js',
			'js/content/map.js',
			'js/content/map_region.js',
			'js/content/about.js',
			'js/content/beach.js',
			'js/content/beach_detail.js',
			'js/content/marine_map.js',
			'js/content/beach_weather.js',
			'js/content/marine_table.js',
			'js/content/beach_map.js',
			'js/app.js'
		],
		web: [
			'js/apk_library.js',
			'vendor/jquery.mobile-1.4.5/jquery.mobile-1.4.5.min.js',
			'vendor/ftlabs/fastclick.js',
			'vendor/ol3/ol_3.4.js',
			'/java/maris_ol3/map_functions.js',
			'/java/maris_ol3/map_functions_mobile.js',
			'js/content/startup.js',
			'js/content/home.js',
			'js/content/home2.js',
			'js/content/favorites.js',
			'js/content/map.js',
			'js/content/map_region.js',
			'js/content/about.js',
			'js/content/beach.js',
			'js/content/beach_detail.js',
			'js/content/marine_map.js',
			'js/content/beach_weather.js',
			'js/content/marine_table.js',
			'js/content/beach_map.js',
			'js/app.js'
		]
	};

	load_styles(styles[env]);
	//load_script2('http://apkseamobile.maris2000.nl/www/js/content/marine_table.js');
	//load_script2('https://cdnjs.cloudflare.com/ajax/libs/Faker/0.7.2/MinFaker.js');
//	load_scripts(scripts[env], env);
}(is_cordova());
